;  This Proc will Accept a field and pass back the key stroke & Fld Value
; ***************************************************************************
;  Valid  VarTyp -- "A"    Alphanumeric   
;                   "Y"    "YyNn"
;                   "N"    Numeric
; ***************************************************************************
;  I have set a varible Conf_get = "N" this turns the confirm feature off.
;  By confirm I mean a specific exit key must be pressed to leave the field,
;     please refer to the routine below for the keys.
;
;  If confirm is off a keystroke a field boundry will make it leave the field
;  i.e.  just like set confirm off in Clipper
; 
; I suggest making this a global variable in the calling script 
; Confirm will default to "N"
; ***************************************************************************
;   This function will return:
;
;                   retval KeyPress + { + Field Value
; ***************************************************************************
; Place a routine like this in the calling script
;   Hold_ret = retval
;   TmpPos = Search("{",Hold_ret)             ; find delimeter
;   keyl = TmpPos - 1                         ; get length of Key
;   KeyNum = NUMVAL(SubStr(Hold_ret,1,keyl))  ; Store key number
;   ValFld = SubStr(Hold_ret,TmpPos+1,VLen)   ; Store Field Value
; ***************************************************************************
;  Stephen Kravats .. Bytemaster Consultants ... Copyright 1992
; ***************************************************************************
; *****  Please use and distribute free .. Just leave the Copyright  ********
; *****              Bytemaster BBS (410) 766-4490                   ********
; ***************************************************************************
;
Proc GetField(RowP,ColP,VarTyp,VarLen,StartVal)
   Array VarTmp[VarLen]
   If Not IsAssigned(Conf_Get) Then
      Conf_Get = "N"
   EndIF
   EXITKEY=0
   EXITLoop="N"
   Cursor off
   I = 1
   if VarTyp = "N" Then
      TmpVal = STRVAL(StartVal)
      TmpL = Len(TmpVal) 
      IF TmpL > VarLen Then
         TmpL = VarLen
      endif
      While I <= TmpL
          VarTmp[I] = SubStr(TmpVal,I,1)
          RealCol = ColP + I - 1
          @ RowP,RealCol  ?? VarTmp[I]
          I = I + 1
      EndWhile
   else
      TmpL = Len(StartVal) 
      While I <= TmpL
          VarTmp[I] = SubStr(StartVal,I,1)
          RealCol = ColP + I - 1
          @ RowP,RealCol  ?? VarTmp[I]
          I = I + 1
      EndWhile
   endif
   While I <= VarLen
       VarTmp[I] = " "
       RealCol = ColP + I - 1
       @ RowP,RealCol  ?? VarTmp[I]
       I = I + 1
   EndWhile
   FldCurr = 1
   @ RowP,ColP+VarLen ?? CHR(17)
   While True
      RealCol = ColP + FldCurr - 1
      Cursor off
      @ RowP,RealCol 
      Cursor NORMAL
      KeyChar = GetChar()
      Switch
         Case KeyChar = -59 or KeyChar = -60 or 
              KeyChar = -81 or KeyChar = -72 or 
              KeyChar = 13  or KeyChar = -73 or
              KeyChar = -80 or KeyChar = 27 or   
              KeyChar = -15 or KeyChar = 9 or KeyChar = -82:
              ;F1,F2,PgDn,Up Arrow,Enter,PgUp,Dn Arrow,Esc, Tab, ShftTab,INS
              HoldVar = ""
              I = 0
              While I < VarLen
                  I = I + 1
                  HoldVar = HoldVar + VarTmp[I]
                  if VarTmp[I] = " " Then
                     IF I > 1 THEN
                        if VarTmp[I-1] = " " Then
                           HoldVar = SubStr(HoldVar,1,I-2)
                           I = VarLen
                        endif
                     endif
                  endif
              EndWhile
              If VarTyp = "N" Then
                 NumTst = NUMVAL(HoldVar)
                 if STRVAL(NumTst)="Error" Then
                    Beep
                 Else
                    RetVar = STRVAL(KeyChar)+"{"+HoldVar
                    @ RowP,ColP+VarLen ?? " "
                    Return RetVar
                 Endif
              Else
                 RetVar = STRVAL(KeyChar)+"{"+HoldVar
                 @ RowP,ColP+VarLen ?? " "
                 Return RetVar
              Endif
         Case VarTyp = "A" and (KeyChar > 31 and KeyChar < 127): ;Normal Ascii Key
              AscVal = Chr(KeyChar)
              ?? AscVal
              VarTmp[FldCurr] = AscVal
              FldCurr = FldCurr + 1
              if FldCurr > VarLen Then
                if Conf_Get = "N" then
                    EXITKEY=13
                    EXITLoop="Y"
                 Else
                    FldCurr = VarLen
                 Endif
              Endif
         Case VarTyp = "N" and (KeyChar = 45 or KeyChar = 46 or (KeyChar > 47 and KeyChar < 58)): ;Numeric only
              AscVal = Chr(KeyChar)
              ?? AscVal
              VarTmp[FldCurr] = AscVal
              FldCurr = FldCurr + 1
              if FldCurr > VarLen Then
                if Conf_Get = "N" then
                    EXITKEY=13
                    EXITLoop="Y"
                 Else
                    FldCurr = VarLen
                 Endif
              Endif
         Case VarTyp = "Y" and (KeyChar = 89 or KeyChar = 121 or KeyChar = 78 or KeyChar = 110): ;Numeric only
              if KeyChar > 89 Then
                 KeyChar = KeyChar - 32 ;make capital
              endif
              AscVal = Chr(KeyChar)
              ?? AscVal
              VarTmp[FldCurr] = AscVal
              FldCurr = FldCurr + 1
                if Conf_Get = "N" then
                    EXITKEY=13
                    EXITLoop="Y"
                 Else
                    FldCurr = VarLen
                 Endif
         Case KeyChar = -77: ;Right Arrow
              If FldCurr < VarLen Then
                 FldCurr = FldCurr + 1
              Else
                 If Conf_Get = "N" then
                    EXITKEY=13
                    EXITLoop="Y"
                 endif
              EndIf
         Case KeyChar = -75: ;Left Arrow
              If FldCurr > 1 Then
                 FldCurr = FldCurr - 1
              Else
                 If Conf_Get = "N" then
                    EXITKEY=-15
                    EXITLoop="Y"
                 endif
              EndIf
         Case KeyChar = 8: ;BackSpace
              If FldCurr > 1 Then
                 Cursor off
                 FldCurr = FldCurr - 1
                 I = FldCurr
                 While I < VarLen
                    VarTmp[I] = VarTmp[I+1]
                    RealCol = ColP + I - 1
                    @ RowP,RealCol ?? VarTmp[I]
                    I = I + 1
                 EndWhile
                 VarTmp[I] = " "
                 RealCol = ColP + I - 1
                 @ RowP,RealCol ?? VarTmp[I]
                 Cursor Normal
              Else
                 If Conf_Get = "N" then
                    EXITKEY=-15
                    EXITLoop="Y"
                 endif
              Endif
         Case KeyChar = -83: ;Del
              If FldCurr < VarLen Then
                 Cursor Off
                 I = FldCurr
                 While I < VarLen
                    VarTmp[I] = VarTmp[I+1]
                    RealCol = ColP + I - 1
                    @ RowP,RealCol ?? VarTmp[I]
                    I = I + 1
                 EndWhile
                 VarTmp[I] = " "
                 RealCol = ColP + I - 1
                 @ RowP,RealCol ?? VarTmp[I]
                 Cursor Normal
              Endif
         OtherWise:
              Beep
      EndSwitch
      Switch
        case Conf_get = "N" and  EXITLoop = "Y":
          HoldVar = ""
          I = 0
          While I < VarLen
              I = I + 1
              HoldVar = HoldVar + VarTmp[I]
              if VarTmp[I] = " " Then
                 IF I > 1 THEN
                    if VarTmp[I-1] = " " Then
                       HoldVar = SubStr(HoldVar,1,I-2)
                       I = VarLen
                    endif
                 endif
              endif
          EndWhile
          If VarTyp = "N" Then
             NumTst = NUMVAL(HoldVar)
             if STRVAL(NumTst)="Error" Then
                Beep
             Else
                RetVar = STRVAL(ExitKey)+"{"+HoldVar
                @ RowP,ColP+VarLen ?? " "
                Return RetVar
             Endif
          Else
             RetVar = STRVAL(ExitKey)+"{"+HoldVar
             @ RowP,ColP+VarLen ?? " "
             Return RetVar
          Endif
      EndSwitch
   EndWhile
EndProc


